<?php
namespace FiloBlu\Popup\Controller\Adminhtml\Popup;

use Magento\Backend\App\Action;

class Delete extends Action
{
    protected $_model;

    /**
     * @param Action\Context $context
     * @param \FiloBlu\Popup\Model\Popup $model
     */
    public function __construct(
        Action\Context $context,
        \FiloBlu\Popup\Model\Popup $model
    ) {
        parent::__construct($context);
        $this->_model = $model;
    }

    /**
     * {@inheritdoc}
     */
    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('Magento_Backend::content');
    }

    /**
     * Delete action
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function execute()
    {
        $id = $this->getRequest()->getParam('id');
        /** @var \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
        $resultRedirect = $this->resultRedirectFactory->create();
        if ($id)
        {
            try
            {
                $model = $this->_model;
                $model->load($id);
                $model->delete();
                $this->messageManager->addSuccess(__('Record deleted'));
                return $resultRedirect->setPath('*/*/index');

            }
            catch (\Exception $e)
            {

                $this->messageManager->addError($e->getMessage());
                return $resultRedirect->setPath('*/*/');
            }
        }

            $this->messageManager->addError(__('There has been and error with the delete process'));
            return $resultRedirect->setPath('*/*/');
    }
}
